/** # Responsive menu

Addon responsive menu.

Accessibilité
`nav#navigation` est necessaire pour le aria-haspopup déclaré par le bouton mobile

.mobile-slide-left - menu mobile aparait par la gauche

Markup:
<header role="banner">
  <div class='responsive-menu js-menumaker $modifierClass'>
		<div class="head-desktop">
			<a href="index.html">
				<div class="brand">Brand name</div>
				<div class="baseline">Baseline</div>
			</a>
		</div>
		<div class="head-mobile">
			<button class="mobile-button menu-opened" aria-haspopup="true" aria-controls="navigation">
          		<span class="visuallyhidden">Navigation</span>
        	</button>
			<div class="brand">Brand Name</div>
			<div class="baseline">Baseline</div>
		</div>
		<nav id="navigation" class="menu-container" role="primary">
			<ul>
			  <li class='active'><a href='#'>HOME</a></li>
			  <li><a href='#'>ABOUT</a></li>
			  <li><a href='#'>PRODUCTS</a>
				<ul>
				  <li><a href='#'>Product 1</a>
					<ul>
					  <li><a href='#'>Sub Product</a></li>
					  <li><a href='#'>Sub Product</a></li>
					</ul>
				  </li>
				  <li><a href='#'>Product 2</a>
					<ul>
					  <li><a href='#'>Sub Product</a></li>
					  <li><a href='#'>Sub Product</a></li>
					</ul>
				  </li>
				</ul>
			  </li>
			  <li><a href='#'>BIO</a></li>
			  <li><a href='#'>VIDEO</a></li>
			  <li><a href='#'>GALLERY</a></li>
			  <li><a href='#'>CONTACT</a></li>
			</ul>
		</nav>
	</div>
</header>

Javascript:
	jQuery(function($){
	  $(".js-menumaker").responsiveMenu({
	     format: "multitoggle",
	     sticky:false,
	     breakpoint:700,
	     cssMenuOpen: 'open'
	  });
	});

@package 	- addons/responsive-menu
@use 			- js - addons/responsive-menu/responsive-menu.js
@see 			- <http://codepen.io/emredenx/pen/ojcxl/>
@link 		- Codepen d'un menu accessible http://codepen.io/grayghostvisuals/pen/ltjDa
@see 		- Theorie menu accessibles : http://simplyaccessible.com/article/better-for-accessibility/
@link 	- https://github.com/nico3333fr/jquery-accessible-subnav-dropdown
@link 	- http://staff.washington.edu/tft/tests/menus/simplyaccessible/index.html
@link 	- Article sur le markup ARIA d'un menu http://terrillthompson.com/blog/202
@link 	- Push menu : inspiration pour le mode dropdown https://tympanus.net/Development/MultiLevelPushMenu/index2.html
@link 	- Construire des menus accessibles : https://www.smashingmagazine.com/2017/11/building-accessible-menu-systems
@see 		-  explication sur l'accessibilité et display:none https://stackoverflow.com/questions/36940108/displaynone-drop-down-menus-and-screen-readers
@see		- The priority pattern http://bradfrost.com/blog/post/revisiting-the-priority-pattern/
@see		- Priority pattern exemple https://www.regionalaustraliabank.com.au/
@todo 	- FramaPad CDC lib menu responsive idéal :  https://demo.codimd.org/A8vQ9ro-Rbigb-0EpDI8OA?both
@todo 	- mieux gerer les themes du menu
@todo 	- Evoluer vers de nouveaux principes ou concept de navigation, comme suggéré Ici https://medium.com/glossier/glossiers-mobile-navigation-4a944e65b0b7
@todo 	- Aria sur le bouton mobile https://www.w3.org/TR/2017/NOTE-wai-aria-practices-1.1-20171214/examples/menu-button/menu-button-links.html

Styleguide addons.responsivemenu
*/

$sans-serif: $base-font-family !default;
$base-transition: all 0.1s linear !default;
$base-background-color: $white !default;
$rm-drop-sub-width: 200px !default;
$rm-menu-mobile-width: 250px !default;
$rm-base-z-index: 1000 !default;
//  top|left … css direction propertie
$rm-appear-direction: top !default;
// pour les screen-reader on evite display:none
@mixin hide-item($appear: $rm-appear-direction){
	max-height: 0;
	height:0;
	opacity: 0;
	$x:0;
	$y:0;
	@if($appear == 'left'){
		$x: -100%;
		$y: 0;
		#{$appear}:-5000px;
	}
	@if($appear == 'right'){
		$x: 100%;
		$y: 0;
		#{$appear}: 5000px;
	}
	@if($appear == 'bottom'){
		$x: 0;
		$y: 100%;
		#{$appear}: 5000px;
	}
	@if($appear == 'top'){
		$x: 0;
		$y: -100%;
		#{$appear}: -5000px;
	}
	transform: translate3d($x,$y,0);
}

@mixin show-item($appear: $rm-appear-direction){
	max-height: none;
	height: auto;
	opacity: 1;
	#{$appear}:0;
	transform: translate3d(0,0,0);
}

// LAYOUT
// [1] Pas de z-index permet de changer l'index du bouton mobile qui est un enfant
.responsive-menu {
	position:relative;
	z-index: $rm-base-z-index - 10; // on intialize le z-index réutilisé plus loin
	.head-desktop {
		display:none;
	}
	.head-mobile {
		position: relative;
		// z-index: $rm-base-z-index ; // [1]
	}
	.mobile-button{
		z-index: $rm-base-z-index + 100;
	}
	.menu-container {
		z-index: $rm-base-z-index + 10;
		&:after{
			z-index: $rm-base-z-index + 5;
		}
		& > ul {
			z-index: $rm-base-z-index + 15;
		}
	}
	@include media('>tablet'){
		width: 100%;
		.head-desktop {
			display:block;
		}
		.head-mobile {
			display:none;
		}
	}
}

//  Styles du bouton hamburger
.responsive-menu .mobile-button ,
.responsive-menu button.mobile-button{
	// Reset default browser buttons styles
	background-color: transparent;
	background: none;
	padding: 0;
	margin: 0;
	cursor: pointer;
	border: 0px solid transparent;
	line-height: normal;
	overflow: visible;
	padding: 0;
	user-select: none;
	font-size: 1.5rem; // Taille de l'icone
	transition: transform .2s linear ;
	//text-indent: -5000px;
	&::before {
		text-indent:0;
		font-size:1.5rem;
	}
	&:focus {
		outline: 0 solid transparent;
		box-shadow: none;
	}
}

.responsive-menu {

	.menu-container{
		& > ul {
			display:block;
			position: absolute;
			height: 100vh;
			overflow-y: auto; // Ici si on en déclare un il faut initialiser les deux axes
			overflow-x: hidden;
			transition: $base-transition ;
			@include media('<=tablet'){
				@include hide-item();
				&.is-open{
				 @include show-item();
						 min-height:100%;
				}
			}
			@include media('>tablet'){
				position: relative;
				top: 0;
				left: 0;
				width: auto; //
				width:initial; //
				height: auto;
				height: initial;
				overflow-y: visible; // Ici si on en déclare un il faut initialiser les deux axes
				overflow-x: visible;
				display: flex;
				justify-content: flex-end;
				align-items: flex-end;
				padding: 0;
			}
		}

		// Style des menu>items
		& ul > li {
			@include media('<=tablet'){
				overflow: hidden;
			}
			@include media('>tablet'){
				display: inline-block;
	    }
		}
		& .open li {
			overflow: auto;
			height: auto;
		}
	}

}

//  Le menu mobile prend toute la largeur de l'écran
.responsive-menu.mobile-full-with {
	// Animation et positionnement du menu mobile ouvert
	//
	& .menu-container > ul {
		width: 100%;
		top: 0;
	}

	@include media(">tablet"){

	}
}


// Le menu mobile arrive a gauche
// le bouton mobile switch entre ouvert/fermé
// et s'aligne avec la largeur max du menu
.responsive-menu.mobile-slide-left {
	 // Accessibilité on utilise un element button
	 @include media("<tablet"){
			.mobile-button,
			button.mobile-button {
				position: relative;
				float: left;
				z-index: $rm-base-z-index + 10;
				padding-right: $small-spacing;
				&.menu-opened {
					z-index: $rm-base-z-index + 150;
					position: fixed;
					top: 0;
					transform: translateX($rm-menu-mobile-width - (strip-unit($base-spacing) / 2));
				}
			}

		  // Animation et positionnement du menu mobile ouvert
		  // $rm-menu-mobile-width: 350px !default;
		  // positionnement = largeur du menu - padding;
		  & .menu-container > ul {
		    width: $rm-menu-mobile-width + 10; //
		    top: 0;
		    padding: $base-spacing;
		  }
	}
}// ./responsive-menu.mobile-slide-left

// Etat ouvert en mode mobile
// Style du fond de menu qui recouvre le reste de la page
// en mode mobile
// On ne style pas en mode large/desktop
@include media('<=tablet'){
  .menu-container.is-open {
    width: 100%;
    height: 100%;
    top:0;
		left: 0;
		position: relative;
		&::after{
			content:'';
			display: block;
			position: fixed;
			top: 0;
			left:0;
			width: 100%;
			height:100%;
		}
  }
}


// First level
.menu-container li > a {
	display: block;
	white-space: nowrap;
	padding:  $small-spacing;

	transition: background .3s linear;

	@include media('>tablet'){
			display: flex;
	}
}
.menu-container li:focus > a,
.menu-container li:hover > a,
.menu-container li > a:hover,
.menu-container li > a:focus{


	@include media('>tablet'){

	}
}

// LAYOUT des sous-menus

.has-sub,
.menu-container ul li { //mieux cibler car la class has-sub n'est pas encore la au chargement
	position: relative; // Assurer le positionnement des sousmenus

	& > ul {
		@include hide-item;

		&.open {
			@include show-item;
		}

		@include media('>tablet'){
			position: absolute;
			width: $rm-drop-sub-width;
			flex-direction: column;
		}
	}

	& > ul ul{
		@include hide-item;

		&.open{
			@include show-item;
		}

		@include media('>tablet'){
			//position: absolute;
			//width: $rm-drop-sub-width;
			top:0;
			margin-left: 100%;
		}
	}
}

.has-sub > a:focus > ul{
	//border-color: red;
}

.has-sub:focus > ul,
.has-sub:hover > ul{
	@include media('>tablet'){
			@include show-item;
	}
}

.menu-container .has-sub {
	& > ul {
		transition: opacity .25s linear;
	}
	& > ul li,
	& > ul li a {
			width: 100%;
			display: block; // remplir l'espace disponible pour le placement du submenu button
	}
}

// Bouton signalant l'arbo du menu avec etat deplie/replie
.submenu-button {
	display: block;
	float: right;
	width: 16px;
	height: 16px;
	margin-left: $small-spacing;
	&:after{
		content:'+';
		font-size:1rem;
	}
	&.submenu-opened {
		&:after {
			content: '-';
		}
	}
}


.responsive-menu {

	.brand, .baseline {

	}

	.brand{

	}
	.baseline {

	}


}


.responsive-menu .head-desktop {



  a {
	 color: contrasted($base-background-color);
  }

  .brand{

  }

  .baseline {

  }

	@include media('>tablet'){
		.brand,.baseline{

		}
  }

}


.responsive-menu .head-mobile {

	.brand,.baseline {

	}
	.brand {
		position: relative;

		@include media('>tablet'){
// 			padding: $small-spacing 0;
		}

	}
	.baseline {
		// @include media('<tablet'){
		// 	@include visuallyhidden();
		// }
	}
}

// MODES

.responsive-menu.multitoggle{
		.menu-container.is-open {
			position:fixed;
		}
		@include media(">tablet"){

			.has-sub:focus > ul,
			.has-sub:hover > ul {
				// top: 3rem; // corrige la hauteur du premier niveau
				& ul {
					top: 0;
				}
			}

			.sub-left {
				margin-left: -100%;
			}

		}
}

.responsive_menu.megadropdown{

}

// ------------------------------------------------*/
// UTILITIES
// ------------------------------------------------*/
// @debug
.responsive-menu .show > ul {
		@include media('>tablet'){
				@include show-item;
		}
}
// Positionnement Sticky
@include media(">tablet"){
	.responsive-menu.sticky {
			position:fixed;
			top:0;
			left: 0;
			min-width: 100%;
			z-index: $rm-base-z-index + 100;
	}
}

// @todo Icones a la place des intitulés de menus

// Alignements des menus et sous menus
.responsive-menu > .menu-container {

}

// Menu cmponents
.responsive-menu form {
	padding: $small-spacing 0;
	margin-bottom: 5px; // border des liens
	& input {
		margin: 0;
	}
}
